package com.napa.pulse.dao.impl;

import org.junit.Test;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.test.util.ReflectionTestUtils;

import java.util.*;

import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.when;

@SpringBootTest
@RunWith( MockitoJUnitRunner.class )

public class AdminConsoleDaoImplUnitTest {
    @Mock
    JdbcTemplate jdbcTemplate;

    @InjectMocks
    AdminConsoleDaoImpl mockAdminConsoleDao;

    @BeforeEach
    public void setup ( ) {
        MockitoAnnotations.initMocks(this);
    }
    @Test
    public void getAdminConsoleDataTest(){
        Map<String,Object> result=new HashMap<>();
        Map<String,Object> finalResult=new HashMap<>();
        finalResult.put("KEY",1);
        List<Map<String,Object>> queryResult =new ArrayList<>();
        queryResult.add(result);
        result.put("DASHBOARD_KEY","KEY");
        result.put("DASHBOARD_VALUE",1);
        ReflectionTestUtils.setField(mockAdminConsoleDao,"jdbcTemplate",jdbcTemplate);
        when(jdbcTemplate.queryForList(anyString())).thenReturn(queryResult);
        Map<String,Object> resultAdmin=mockAdminConsoleDao.getAdminConsoleData("12-aug-2022","14-mar-2029");
        Assertions.assertEquals(finalResult,resultAdmin);
    }

}
