package com.napa.pulse.dao.impl;

import org.junit.Test;
import org.junit.jupiter.api.BeforeEach;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.jdbc.core.JdbcTemplate;

import static org.mockito.Mockito.*;

/**
 * @author Aqueel Ahmad
 * 26/8/2022
 */
@SpringBootTest
@RunWith ( MockitoJUnitRunner.class )
public class FleetDAOImplUnitTest {
    @Mock
    JdbcTemplate jdbcTemplate;

    @InjectMocks
    FleetDAOImpl mockFleetDAOImpl;

    @BeforeEach
    public void setup() {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void testRenameFleetGroup ( ) {
        mockFleetDAOImpl = mock(FleetDAOImpl.class);
        mockFleetDAOImpl.renameFleetGroup(1, "test");
       verify(mockFleetDAOImpl, times(1)).renameFleetGroup(1, "test");
    }

    @Test(expected = Exception.class)
    public void testRenameFleetGroupException() {
        mockFleetDAOImpl = mock(FleetDAOImpl.class);
        when(jdbcTemplate.update("update FLEET set FLEET_NAME = ? where FLEET_ID = ?", 1, "test")).thenThrow(Exception.class);
    }

}
